Index: contrib/ipfilter/ipmon.c
===================================================================
RCS file: /cvs/DragonFly/src/contrib/ipfilter/ipmon.c,v
retrieving revision 1.2
diff -u -p -u -r1.2 ipmon.c
--- contrib/ipfilter/ipmon.c	17 Jun 2003 04:24:02 -0000	1.2
+++ contrib/ipfilter/ipmon.c	17 Jul 2004 04:55:54 -0000
@@ -1,5 +1,5 @@
 /* $FreeBSD: src/contrib/ipfilter/ipmon.c,v 1.5.2.7 2003/03/01 03:55:51 darrenr Exp $ */
-/* $DragonFly: src/contrib/ipfilter/ipmon.c,v 1.2 2003/06/17 04:24:02 dillon Exp $ */
+/* $FreeBSD: src/contrib/ipfilter/ipmon.c,v 1.5.2.8 2004/07/04 09:24:39 darrenr Exp $ */
 /*
  * Copyright (C) 1993-2002 by Darren Reed.
  *
@@ -993,7 +993,7 @@ int	blen;
 		p = (u_short)ip6->ip6_nxt;
 		s = (u_32_t *)&ip6->ip6_src;
 		d = (u_32_t *)&ip6->ip6_dst;
-		plen = ntohs(ip6->ip6_plen);
+		plen = hl + ntohs(ip6->ip6_plen);
 #else
 		sprintf(t, "ipv6");
 		goto printipflog;
@@ -1107,11 +1107,12 @@ int	blen;
 					ipc->ip_hl << 2, i);
 				t += strlen(t);
 				if (ipoff & IP_OFFMASK) {
-					(void) sprintf(t, " frag %s%s%hu@%hu",
-						ipoff & IP_MF ? "+" : "",
-						ipoff & IP_DF ? "-" : "",
+					(void) sprintf(t, " (frag %d:%hu@%hu%s%s)",
+						ntohs(ipc->ip_id),
 						i - (ipc->ip_hl<<2),
-						(ipoff & IP_OFFMASK) << 3);
+						(ipoff & IP_OFFMASK) << 3,
+						ipoff & IP_MF ? "+" : "",
+						ipoff & IP_DF ? "-" : "");
 				}
 			}
 		}
@@ -1122,10 +1123,11 @@ int	blen;
 			hostname(res, v, d), proto, hl, plen);
 		t += strlen(t);
 		if (off & IP_OFFMASK)
-			(void) sprintf(t, " frag %s%s%hu@%hu",
+			(void) sprintf(t, " (frag %d:%hu@%hu%s%s)",
+				ntohs(ip->ip_id),
+				plen - hl, (off & IP_OFFMASK) << 3,
 				ipoff & IP_MF ? "+" : "",
-				ipoff & IP_DF ? "-" : "",
-				plen - hl, (off & IP_OFFMASK) << 3);
+				ipoff & IP_DF ? "-" : "");
 	}
 	t += strlen(t);
 
Index: contrib/ipfilter/ipnat.c
===================================================================
RCS file: /cvs/DragonFly/src/contrib/ipfilter/ipnat.c,v
retrieving revision 1.1
diff -u -p -u -r1.1 ipnat.c
--- contrib/ipfilter/ipnat.c	17 Jun 2003 02:44:51 -0000	1.1
+++ contrib/ipfilter/ipnat.c	17 Jul 2004 04:55:54 -0000
@@ -60,7 +60,7 @@ extern	char	*sys_errlist[];
 
 #if !defined(lint)
 static const char sccsid[] ="@(#)ipnat.c	1.9 6/5/96 (C) 1993 Darren Reed";
-static const char rcsid[] = "@(#)$Id: ipnat.c,v 2.16.2.22 2002/12/06 11:40:26 darrenr Exp $";
+static const char rcsid[] = "@(#)$Id: ipnat.c,v 2.16.2.25 2003/06/05 14:00:28 darrenr Exp $";
 #endif
 
 
@@ -71,27 +71,31 @@ int	use_inet6 = 0;
 char	thishost[MAXHOSTNAMELEN];
 
 extern	char	*optarg;
+extern	int	optind;
+#if 0
 extern	ipnat_t	*natparse __P((char *, int));
+#endif
 extern	void	natparsefile __P((int, char *, int));
 extern	void	printnat __P((ipnat_t *, int));
 extern	void	printactivenat __P((nat_t *, int));
 extern	void	printhostmap __P((hostmap_t *, u_int));
 extern	char	*getsumd __P((u_32_t));
 
-void	dostats __P((natstat_t *, int)), flushtable __P((int, int));
+static int	dostats __P((natstat_t *, int));
+static int	flushtable __P((int, int));
 void	usage __P((char *));
 int	countbits __P((u_32_t));
 char	*getnattype __P((ipnat_t *));
 int	main __P((int, char*[]));
 void	printaps __P((ap_session_t *, int));
-void	showhostmap __P((natstat_t *nsp));
-void	natstat_dead __P((natstat_t *, char *));
+static int	showhostmap __P((natstat_t *nsp));
+static int	natstat_dead __P((natstat_t *, char *));
 
 
 void usage(name)
 char *name;
 {
-	fprintf(stderr, "%s: [-CFhlnrsv] [-f filename]\n", name);
+	fprintf(stderr, "Usage: %s [-CFhlnrsv] [-f filename]\n", name);
 	exit(1);
 }
 
@@ -153,10 +157,14 @@ char *argv[];
 		case 'v' :
 			opts |= OPT_VERBOSE;
 			break;
+		case '?' :
 		default :
 			usage(argv[0]);
 		}
 
+	if (optind < 2)
+		usage(argv[0]);
+
 	if ((kernel != NULL) || (core != NULL)) {
 		(void) setgid(getgid());
 		(void) setuid(getuid());
@@ -189,27 +197,36 @@ char *argv[];
 		if (openkmem(kernel, core) == -1)
 			exit(1);
 
-		natstat_dead(nsp, kernel);
-		if (opts & (OPT_LIST|OPT_STAT))
-			dostats(nsp, opts);
+		if (natstat_dead(nsp, kernel))
+			exit(1);
+		if (opts & (OPT_LIST|OPT_STAT)) {
+			if (dostats(nsp, opts))
+				exit(1);
+		}
 		exit(0);
 	}
 
 	if (opts & (OPT_FLUSH|OPT_CLEAR))
-		flushtable(fd, opts);
-	if (file)
+		if (flushtable(fd, opts))
+		    exit(1);
+	if (file) {
+		/* NB natparsefile exits with nonzero in case of error */
 		natparsefile(fd, file, opts);
+	}
 	if (opts & (OPT_LIST|OPT_STAT))
-		dostats(nsp, opts);
+		if (dostats(nsp, opts))
+			exit(1);
+
+	/* TBD why not exit(0)? */
 	return 0;
 }
 
 
 /*
- * Read nat statistic information in using a symbol table and memory file
+ * Read NAT statistic information in using a symbol table and memory file
  * rather than doing ioctl's.
  */
-void natstat_dead(nsp, kernel)
+static int natstat_dead(nsp, kernel)
 natstat_t *nsp;
 char *kernel;
 {
@@ -229,12 +246,12 @@ char *kernel;
 
 	if (nlist(kernel, nat_nlist) == -1) {
 		fprintf(stderr, "nlist error\n");
-		return;
+		return -1;
 	}
 
 	/*
 	 * Normally the ioctl copies all of these values into the structure
-	 * for us, before returning it to useland, so here we must copy each
+	 * for us, before returning it to userland, so here we must copy each
 	 * one in individually.
 	 */
 	kmemcpy((char *)&tables, nat_nlist[0].n_value, sizeof(tables));
@@ -257,18 +274,21 @@ char *kernel;
 		sizeof(nsp->ns_instances));
 	kmemcpy((char *)&nsp->ns_apslist, nat_nlist[8].n_value,
 		sizeof(nsp->ns_apslist));
+
+	return 0;
 }
 
 
 /*
  * Display NAT statistics.
  */
-void dostats(nsp, opts)
+static int dostats(nsp, opts)
 natstat_t *nsp;
 int opts;
 {
 	nat_t **nt[2], *np, nat;
 	ipnat_t	ipn;
+	int rc = 0;
 
 	/*
 	 * Show statistics ?
@@ -297,6 +317,7 @@ int opts;
 			if (kmemcpy((char *)&ipn, (long)nsp->ns_list,
 				    sizeof(ipn))) {
 				perror("kmemcpy");
+				rc = -1;
 				break;
 			}
 			if (opts & OPT_HITS)
@@ -309,28 +330,40 @@ int opts;
 		if (kmemcpy((char *)nt[0], (long)nsp->ns_table[0],
 			    sizeof(**nt) * NAT_SIZE)) {
 			perror("kmemcpy");
-			return;
+			rc = -1;
+		}
+		if (rc) {
+			free(nt[0]);
+			return rc;
 		}
 
 		printf("\nList of active sessions:\n");
 
 		for (np = nsp->ns_instances; np; np = nat.nat_next) {
-			if (kmemcpy((char *)&nat, (long)np, sizeof(nat)))
+			if (kmemcpy((char *)&nat, (long)np, sizeof(nat))) {
+				/* TBD Is this an error? If so, return -1 */
 				break;
+			}
 			printactivenat(&nat, opts);
 		}
 
-		if (opts & OPT_VERBOSE)
-			showhostmap(nsp);
+		if (opts & OPT_VERBOSE) {
+			if (showhostmap(nsp)) {
+				free(nt[0]);
+				return -1;
+			}
+		}
+
 		free(nt[0]);
 	}
+	return 0;
 }
 
 
 /*
- * display the active host mapping table.
+ * Display the active host mapping table.
  */
-void showhostmap(nsp)
+static int showhostmap(nsp)
 natstat_t *nsp;
 {
 	hostmap_t hm, *hmp, **maptable;
@@ -343,7 +376,8 @@ natstat_t *nsp;
 	if (kmemcpy((char *)maptable, (u_long)nsp->ns_maptable,
 		    sizeof(hostmap_t *) * nsp->ns_hostmap_sz)) {
 		perror("kmemcpy (maptable)");
-		return;
+		free(maptable);
+		return -1;
 	}
 
 	for (hv = 0; hv < nsp->ns_hostmap_sz; hv++) {
@@ -352,7 +386,8 @@ natstat_t *nsp;
 		while (hmp) {
 			if (kmemcpy((char *)&hm, (u_long)hmp, sizeof(hm))) {
 				perror("kmemcpy (hostmap)");
-				return;
+				free(maptable);
+				return -1;
 			}
 
 			printhostmap(&hm, hv);
@@ -360,6 +395,7 @@ natstat_t *nsp;
 		}
 	}
 	free(maptable);
+	return 0;
 }
 
 
@@ -367,24 +403,31 @@ natstat_t *nsp;
  * Issue an ioctl to flush either the NAT rules table or the active mapping
  * table or both.
  */
-void flushtable(fd, opts)
+static int flushtable(fd, opts)
 int fd, opts;
 {
 	int n = 0;
+	int rc = 0;
 
 	if (opts & OPT_FLUSH) {
 		n = 0;
-		if (!(opts & OPT_NODO) && ioctl(fd, SIOCIPFFL, &n) == -1)
+		if (!(opts & OPT_NODO) && ioctl(fd, SIOCIPFFL, &n) == -1) {
 			perror("ioctl(SIOCFLNAT)");
-		else
+			rc = -1;
+		} else {
 			printf("%d entries flushed from NAT table\n", n);
+		}
 	}
 
 	if (opts & OPT_CLEAR) {
 		n = 1;
-		if (!(opts & OPT_NODO) && ioctl(fd, SIOCIPFFL, &n) == -1)
+		if (!(opts & OPT_NODO) && ioctl(fd, SIOCIPFFL, &n) == -1) {
 			perror("ioctl(SIOCCNATL)");
-		else
+			rc = -1;
+		} else {
 			printf("%d entries flushed from NAT list\n", n);
+		}
 	}
+
+	return rc;
 }
Index: contrib/ipfilter/ipt.c
===================================================================
RCS file: /cvs/DragonFly/src/contrib/ipfilter/ipt.c,v
retrieving revision 1.2
diff -u -p -u -r1.2 ipt.c
--- contrib/ipfilter/ipt.c	6 Jan 2004 03:17:19 -0000	1.2
+++ contrib/ipfilter/ipt.c	17 Jul 2004 04:55:54 -0000
@@ -64,7 +64,7 @@
 
 #if !defined(lint)
 static const char sccsid[] = "@(#)ipt.c	1.19 6/3/96 (C) 1993-2000 Darren Reed";
-static const char rcsid[] = "@(#)$Id: ipt.c,v 2.6.2.24 2002/12/06 11:40:26 darrenr Exp $";
+static const char rcsid[] = "@(#)$Id: ipt.c,v 2.6.2.26 2003/11/09 17:22:21 darrenr Exp $";
 #endif
 
 extern	char	*optarg;
@@ -72,7 +72,7 @@ extern	struct frentry	*ipfilter[2][2];
 extern	struct ipread	snoop, etherf, tcpd, pcap, iptext, iphex;
 extern	struct ifnet	*get_unit __P((char *, int));
 extern	void	init_ifp __P((void));
-extern	ipnat_t	*natparse __P((char *, int));
+extern	ipnat_t	*natparse __P((char *, int, int *));
 extern	int	fr_running;
 
 int	opts = 0;
@@ -310,6 +310,7 @@ char *file;
 	int     linenum, i;
 	void	*fr;
 	FILE	*fp;
+	int	parsestatus;
 
 	if (!strcmp(file, "-"))
 		fp = stdin;
@@ -346,7 +347,21 @@ char *file;
 		/* fake an `ioctl' call :) */
 
 		if ((opts & OPT_NAT) != 0) {
-			if (!(fr = natparse(line, linenum)))
+			parsestatus = 1;
+			fr = natparse(line, linenum, &parsestatus);
+			if (parsestatus != 0) {
+				if (*line) {
+					fprintf(stderr,
+					    "%d: syntax error in \"%s\"\n",
+					    linenum, line);
+				}
+				fprintf(stderr, "%s: %s error (%d), quitting\n",
+				    file,
+				    ((parsestatus < 0)? "parse": "internal"),
+				    parsestatus);
+				exit(1);
+			}
+			if (!fr)
 				continue;
 
 			if (rremove == 0) {
@@ -367,8 +382,19 @@ char *file;
 						fr, i);
 			}
 		} else {
-			if (!(fr = parse(line, linenum)))
+			fr = parse(line, linenum, &parsestatus);
+
+			if (parsestatus != 0) {
+			    fprintf(stderr, "%s: %s error (%d), quitting\n",
+				file,
+				((parsestatus < 0)? "parse": "internal"),
+				parsestatus);
+			    exit(1);
+			}
+
+			if (!fr) {
 				continue;
+			}
 
 			if (rremove == 0) {
 				i = IPL_EXTERN(ioctl)(0, SIOCADAFR,
Index: contrib/ipfilter/kmem.c
===================================================================
RCS file: /cvs/DragonFly/src/contrib/ipfilter/kmem.c,v
retrieving revision 1.2
diff -u -p -u -r1.2 kmem.c
--- contrib/ipfilter/kmem.c	6 Jan 2004 03:17:19 -0000	1.2
+++ contrib/ipfilter/kmem.c	17 Jul 2004 04:55:54 -0000
@@ -46,14 +46,14 @@
 
 #if !defined(lint)
 static const char sccsid[] = "@(#)kmem.c	1.4 1/12/96 (C) 1992 Darren Reed";
-static const char rcsid[] = "@(#)$Id: kmem.c,v 2.2.2.16 2002/12/06 11:40:27 darrenr Exp $";
+static const char rcsid[] = "@(#)$Id: kmem.c,v 2.2.2.18 2003/11/09 17:22:22 darrenr Exp $";
 #endif
 
 #ifdef	__sgi
 typedef	int 	kvm_t;
 
 static	int	kvm_fd = -1;
-static	char	*kvm_errstr;
+static	char	*kvm_errstr = NULL;
 
 kvm_t *kvm_open(kernel, core, swap, mode, errstr)
 char *kernel, *core, *swap;
@@ -79,8 +79,10 @@ size_t size;
 	int r;
 
 	if (lseek(*kvm, pos, 0) == -1) {
-		fprintf(stderr, "%s", kvm_errstr);
-		perror("lseek");
+		if (kvm_errstr != NULL) {
+			fprintf(stderr, "%s:", kvm_errstr);
+			perror("lseek");
+		}
 		return -1;
 	}
 
@@ -103,7 +105,7 @@ char	*kern, *core;
 		kvm_t *uk;
 	} k;
 
-	kvm_f = kvm_open(kern, core, NULL, O_RDONLY, "");
+	kvm_f = kvm_open(kern, core, NULL, O_RDONLY, NULL);
 	if (kvm_f == NULL)
 	    {
 		perror("openkmem:open");
Index: contrib/ipfilter/mln_ipl.c
===================================================================
RCS file: /cvs/DragonFly/src/contrib/ipfilter/mln_ipl.c,v
retrieving revision 1.1
diff -u -p -u -r1.1 mln_ipl.c
--- contrib/ipfilter/mln_ipl.c	17 Jun 2003 02:44:52 -0000	1.1
+++ contrib/ipfilter/mln_ipl.c	17 Jul 2004 04:55:54 -0000
@@ -220,7 +220,9 @@ static int ipl_remove()
 #ifdef OpenBSD
 		VOP_LOCK(nd.ni_vp, LK_EXCLUSIVE | LK_RETRY, curproc);
 #else
+# if !defined(__NetBSD_Version__) || (__NetBSD_Version__ < 106000000)
 		vn_lock(nd.ni_vp, LK_EXCLUSIVE | LK_RETRY);
+# endif
 #endif
 		VOP_LEASE(nd.ni_dvp, curproc, curproc->p_ucred, LEASE_WRITE);
 		(void) VOP_REMOVE(nd.ni_dvp, nd.ni_vp, &nd.ni_cnd);
Index: contrib/ipfilter/natparse.c
===================================================================
RCS file: /cvs/DragonFly/src/contrib/ipfilter/natparse.c,v
retrieving revision 1.1
diff -u -p -u -r1.1 natparse.c
--- contrib/ipfilter/natparse.c	17 Jun 2003 02:44:52 -0000	1.1
+++ contrib/ipfilter/natparse.c	17 Jul 2004 04:55:54 -0000
@@ -56,7 +56,7 @@ extern	char	*sys_errlist[];
 
 #if !defined(lint)
 static const char sccsid[] ="@(#)ipnat.c	1.9 6/5/96 (C) 1993 Darren Reed";
-static const char rcsid[] = "@(#)$Id: natparse.c,v 1.17.2.27 2002/12/06 11:40:27 darrenr Exp $";
+static const char rcsid[] = "@(#)$Id: natparse.c,v 1.17.2.29 2003/05/15 17:45:34 darrenr Exp $";
 #endif
 
 
@@ -68,7 +68,7 @@ extern	void	printnat __P((ipnat_t *, int
 extern	int	countbits __P((u_32_t));
 extern	char	*proto;
 
-ipnat_t	*natparse __P((char *, int));
+ipnat_t	*natparse __P((char *, int, int *));
 void	natparsefile __P((int, char *, int));
 void	nat_setgroupmap __P((struct ipnat *));
 
@@ -98,10 +98,16 @@ ipnat_t *n;
 
 /*
  * Parse a line of input from the ipnat configuration file
+ *
+ * status:
+ *	< 0	error
+ *	= 0	OK
+ *	> 0	programmer error
  */
-ipnat_t *natparse(line, linenum)
+ipnat_t *natparse(line, linenum, status)
 char *line;
 int linenum;
+int *status;
 {
 	static ipnat_t ipn;
 	struct protoent *pr;
@@ -110,6 +116,7 @@ int linenum;
 	int i, cnt;
 	char *port1a = NULL, *port1b = NULL, *port2a = NULL;
 
+	*status = 100;		/* default to error */
 	proto = NULL;
 
 	/*
@@ -121,8 +128,10 @@ int linenum;
 		*s = '\0';
 	while (*line && isspace(*line))
 		line++;
-	if (!*line)
+	if (!*line) {
+		*status = 0;
 		return NULL;
+	}
 
 	bzero((char *)&ipn, sizeof(ipn));
 	cnt = 0;
@@ -137,6 +146,7 @@ int linenum;
 
 	if (cnt < 3) {
 		fprintf(stderr, "%d: not enough segments in line\n", linenum);
+		*status = -1;
 		return NULL;
 	}
 
@@ -156,6 +166,7 @@ int linenum;
 	else {
 		fprintf(stderr, "%d: unknown mapping: \"%s\"\n",
 			linenum, *cpp);
+		*status = -1;
 		return NULL;
 	}
 
@@ -174,12 +185,14 @@ int linenum;
 			cpp++;
 			if (strcasecmp(*cpp, "from")) {
 				fprintf(stderr, "Missing from after !\n");
+				*status = -1;
 				return NULL;
 			}
 			ipn.in_flags |= IPN_NOTSRC;
 		} else if (**cpp == '!') {
 			if (strcasecmp(*cpp + 1, "from")) {
 				fprintf(stderr, "Missing from after !\n");
+				*status = -1;
 				return NULL;
 			}
 			ipn.in_flags |= IPN_NOTSRC;
@@ -187,6 +200,7 @@ int linenum;
 		if ((ipn.in_flags & IPN_NOTSRC) &&
 		    (ipn.in_redir & (NAT_MAP|NAT_MAPBLK))) {
 			fprintf(stderr, "Cannot use '! from' with map\n");
+			*status = -1;
 			return NULL;
 		}
 
@@ -196,12 +210,14 @@ int linenum;
 			if (hostmask(&cpp, (u_32_t *)&ipn.in_srcip,
 				     (u_32_t *)&ipn.in_srcmsk, &ipn.in_sport,
 				     &ipn.in_scmp, &ipn.in_stop, linenum)) {
+				*status = -1;
 				return NULL;
 			}
 		} else {
 			if (hostmask(&cpp, (u_32_t *)&ipn.in_inip,
 				     (u_32_t *)&ipn.in_inmsk, &ipn.in_sport,
 				     &ipn.in_scmp, &ipn.in_stop, linenum)) {
+				*status = -1;
 				return NULL;
 			}
 		}
@@ -217,22 +233,26 @@ int linenum;
 		if (strcasecmp(*cpp, "to")) {
 			fprintf(stderr, "%d: unexpected keyword (%s) - to\n",
 				linenum, *cpp);
+			*status = -1;
 			return NULL;
 		}
 		if ((ipn.in_flags & IPN_NOTDST) &&
 		    (ipn.in_redir & (NAT_REDIRECT))) {
 			fprintf(stderr, "Cannot use '! to' with rdr\n");
+			*status = -1;
 			return NULL;
 		}
 
 		if (!*++cpp) {
 			fprintf(stderr, "%d: missing host after to\n", linenum);
+			*status = -1;
 			return NULL;
 		}
 		if (ipn.in_redir == NAT_REDIRECT) {
 			if (hostmask(&cpp, (u_32_t *)&ipn.in_outip,
 				     (u_32_t *)&ipn.in_outmsk, &ipn.in_dport,
 				     &ipn.in_dcmp, &ipn.in_dtop, linenum)) {
+				*status = -1;
 				return NULL;
 			}
 			ipn.in_pmin = htons(ipn.in_dport);
@@ -240,6 +260,7 @@ int linenum;
 			if (hostmask(&cpp, (u_32_t *)&ipn.in_srcip,
 				     (u_32_t *)&ipn.in_srcmsk, &ipn.in_dport,
 				     &ipn.in_dcmp, &ipn.in_dtop, linenum)) {
+				*status = -1;
 				return NULL;
 			}
 		}
@@ -247,30 +268,39 @@ int linenum;
 		s = *cpp;
 		if (!s) {
 			fprintf(stderr, "%d: short line\n", linenum);
+			*status = -1;
 			return NULL;
 		}
 		t = strchr(s, '/');
 		if (!t) {
 			fprintf(stderr, "%d: no netmask on LHS\n", linenum);
+			*status = -1;
 			return NULL;
 		}
 		*t++ = '\0';
 		if (ipn.in_redir == NAT_REDIRECT) {
-			if (hostnum((u_32_t *)&ipn.in_outip, s, linenum) == -1)
+			if (hostnum((u_32_t *)&ipn.in_outip, s, linenum) == -1){
+				*status = -1;
 				return NULL;
+			}
 			if (genmask(t, (u_32_t *)&ipn.in_outmsk) == -1) {
+				*status = -1;
 				return NULL;
 			}
 		} else {
-			if (hostnum((u_32_t *)&ipn.in_inip, s, linenum) == -1)
+			if (hostnum((u_32_t *)&ipn.in_inip, s, linenum) == -1) {
+				*status = -1;
 				return NULL;
+			}
 			if (genmask(t, (u_32_t *)&ipn.in_inmsk) == -1) {
+				*status = -1;
 				return NULL;
 			}
 		}
 		cpp++;
 		if (!*cpp) {
 			fprintf(stderr, "%d: short line\n", linenum);
+			*status = -1;
 			return NULL;
 		}
 	}
@@ -283,6 +313,7 @@ int linenum;
 		if (strcasecmp(*cpp, "port")) {
 			fprintf(stderr, "%d: missing fields - 1st port\n",
 				linenum);
+			*status = -1;
 			return NULL;
 		}
 
@@ -292,6 +323,7 @@ int linenum;
 			fprintf(stderr,
 				"%d: missing fields (destination port)\n",
 				linenum);
+			*status = -1;
 			return NULL;
 		}
 
@@ -319,10 +351,12 @@ int linenum;
 	 */
 	if (!*cpp) {
 		fprintf(stderr, "%d: missing fields (->)\n", linenum);
+		*status = -1;
 		return NULL;
 	}
 	if (strcmp(*cpp, "->")) {
 		fprintf(stderr, "%d: missing ->\n", linenum);
+		*status = -1;
 		return NULL;
 	}
 	cpp++;
@@ -330,6 +364,7 @@ int linenum;
 	if (!*cpp) {
 		fprintf(stderr, "%d: missing fields (%s)\n",
 			linenum, ipn.in_redir ? "destination" : "target");
+		*status = -1;
 		return NULL;
 	}
 
@@ -341,6 +376,7 @@ int linenum;
 				fprintf(stderr, "%d: missing fields (%s)\n",
 					linenum,
 					ipn.in_redir ? "destination":"target");
+				*status = -1;
 				return NULL;
 			}
 		}
@@ -358,6 +394,7 @@ int linenum;
 			fprintf(stderr,
 				"%d: desination range not specified\n",
 				linenum);
+			*status = -1;
 			return NULL;
 		}
 	} else if (ipn.in_redir != NAT_REDIRECT) {
@@ -371,6 +408,7 @@ int linenum;
 			fprintf(stderr,
 				"%d: missing fields (dest netmask)\n",
 				linenum);
+			*status = -1;
 			return NULL;
 		}
 		if (*dnetm == '/')
@@ -383,20 +421,25 @@ int linenum;
 			ipn.in_flags |= IPN_SPLIT;
 			*dnetm++ = '\0';
 		}
-		if (hostnum((u_32_t *)&ipn.in_inip, *cpp, linenum) == -1)
+		if (hostnum((u_32_t *)&ipn.in_inip, *cpp, linenum) == -1) {
+			*status = -1;
 			return NULL;
+		}
 #if SOLARIS
 		if (ntohl(ipn.in_inip) == INADDR_LOOPBACK) {
 			fprintf(stderr,
 				"localhost as destination not supported\n");
+			*status = -1;
 			return NULL;
 		}
 #endif
 	} else {
 		if (!strcmp(*cpp, ipn.in_ifname))
 			*cpp = "0";
-		if (hostnum((u_32_t *)&ipn.in_outip, *cpp, linenum) == -1)
+		if (hostnum((u_32_t *)&ipn.in_outip, *cpp, linenum) == -1) {
+			*status = -1;
 			return NULL;
+		}
 	}
 	cpp++;
 
@@ -406,6 +449,7 @@ int linenum;
 				fprintf(stderr,
 					"%d: expected \"ports\" - got \"%s\"\n",
 					linenum, *cpp);
+				*status = -1;
 				return NULL;
 			}
 			cpp++;
@@ -413,6 +457,7 @@ int linenum;
 				fprintf(stderr,
 					"%d: missing argument to \"ports\"\n",
 					linenum);
+				*status = -1;
 				return NULL;
 			}
 			if (!strcasecmp(*cpp, "auto"))
@@ -426,12 +471,14 @@ int linenum;
 		if (*cpp && (strrchr(*cpp, '/') != NULL)) {
 			fprintf(stderr, "%d: No netmask supported in %s\n",
 				linenum, "destination host for redirect");
+			*status = -1;
 			return NULL;
 		}
 
 		if (!*cpp) {
 			fprintf(stderr, "%d: Missing destination port %s\n",
 				linenum, "in redirect");
+			*status = -1;
 			return NULL;
 		}
 
@@ -440,6 +487,7 @@ int linenum;
 		if (strcasecmp(*cpp, "port")) {
 			fprintf(stderr, "%d: missing fields - 2nd port (%s)\n",
 				linenum, *cpp);
+			*status = -1;
 			return NULL;
 		}
 		cpp++;
@@ -447,6 +495,7 @@ int linenum;
 			fprintf(stderr,
 				"%d: missing fields (destination port)\n",
 				linenum);
+			*status = -1;
 			return NULL;
 		}
 
@@ -458,17 +507,25 @@ int linenum;
 	if (ipn.in_redir & (NAT_MAP|NAT_MAPBLK)) {
 		if (ipn.in_flags & IPN_IPRANGE) {
 			if (hostnum((u_32_t *)&ipn.in_outmsk, dnetm,
-				    linenum) == -1)
+				    linenum) == -1) {
+				*status = -1;
 				return NULL;
-		} else if (genmask(dnetm, (u_32_t *)&ipn.in_outmsk))
+			}
+		} else if (genmask(dnetm, (u_32_t *)&ipn.in_outmsk)) {
+			*status = -1;
 			return NULL;
+		}
 	} else {
 		if (ipn.in_flags & IPN_SPLIT) {
 			if (hostnum((u_32_t *)&ipn.in_inmsk, dnetm,
-				    linenum) == -1)
+				    linenum) == -1) {
+				*status = -1;
 				return NULL;
-		} else if (genmask("255.255.255.255", (u_32_t *)&ipn.in_inmsk))
+			}
+		} else if (genmask("255.255.255.255", (u_32_t *)&ipn.in_inmsk)){
+			*status = -1;
 			return NULL;
+		}
 		if (!*cpp) {
 			ipn.in_flags |= IPN_TCP; /* XXX- TCP only by default */
 			proto = "tcp";
@@ -494,6 +551,7 @@ int linenum;
 						fprintf(stderr,
 						"%d: Unknown protocol %s\n",
 							linenum, proto);
+						*status = -1;
 						return NULL;
 					} else
 						ipn.in_p = atoi(proto);
@@ -520,6 +578,7 @@ int linenum;
 					fprintf(stderr,
 						"%d: age with no parameters\n",
 						linenum);
+					*status = -1;
 					return NULL;
 				}
 
@@ -541,6 +600,7 @@ int linenum;
 					fprintf(stderr,
 					   "%d: mssclamp with no parameters\n",
 						linenum);
+					*status = -1;
 					return NULL;
 				}
 			}
@@ -549,26 +609,33 @@ int linenum;
 				fprintf(stderr,
 				"%d: extra junk at the end of the line: %s\n",
 					linenum, *cpp);
+				*status = -1;
 				return NULL;
 			}
 		}
 	}
 
 	if ((ipn.in_redir == NAT_REDIRECT) && !(ipn.in_flags & IPN_FILTER)) {
-		if (!portnum(port1a, &ipn.in_pmin, linenum))
+		if (!portnum(port1a, &ipn.in_pmin, linenum)) {
+			*status = -1;
 			return NULL;
+		}
 		ipn.in_pmin = htons(ipn.in_pmin);
 		if (port1b != NULL) {
-			if (!portnum(port1b, &ipn.in_pmax, linenum))
+			if (!portnum(port1b, &ipn.in_pmax, linenum)) {
+				*status = -1;
 				return NULL;
+			}
 			ipn.in_pmax = htons(ipn.in_pmax);
 		} else
 			ipn.in_pmax = ipn.in_pmin;
 	}
 
 	if ((ipn.in_redir & NAT_BIMAP) == NAT_REDIRECT) {
-		if (!portnum(port2a, &ipn.in_pnext, linenum))
+		if (!portnum(port2a, &ipn.in_pnext, linenum)) {
+			*status = -1;
 			return NULL;
+		}
 		ipn.in_pnext = htons(ipn.in_pnext);
 	}
 
@@ -586,13 +653,18 @@ int linenum;
 		ipn.in_flags |= IPN_FRAG;
 	}
 
-	if (!*cpp)
+	if (!*cpp) {
+		*status = 0;
 		return &ipn;
+	}
 
 	if (ipn.in_redir != NAT_BIMAP && !strcasecmp(*cpp, "proxy")) {
+		u_short pport;
+
 		if (ipn.in_redir == NAT_BIMAP) {
 			fprintf(stderr, "%d: cannot use proxy with bimap\n",
 				linenum);
+			*status = -1;
 			return NULL;
 		}
 		cpp++;
@@ -600,6 +672,7 @@ int linenum;
 			fprintf(stderr,
 				"%d: missing parameter for \"proxy\"\n",
 				linenum);
+			*status = -1;
 			return NULL;
 		}
 		dport = NULL;
@@ -610,6 +683,7 @@ int linenum;
 				fprintf(stderr,
 					"%d: missing parameter for \"port\"\n",
 					linenum);
+				*status = -1;
 				return NULL;
 			}
 
@@ -620,11 +694,13 @@ int linenum;
 				fprintf(stderr,
 					"%d: missing parameter for \"proxy\"\n",
 					linenum);
+				*status = -1;
 				return NULL;
 			}
 		} else {
 			fprintf(stderr,
 				"%d: missing keyword \"port\"\n", linenum);
+			*status = -1;
 			return NULL;
 		}
 
@@ -637,9 +713,17 @@ int linenum;
 		} else
 			ipn.in_p = 0;
 
-		if (dport && !portnum(dport, &ipn.in_dport, linenum))
+		if (dport && !portnum(dport, &pport, linenum))
 			return NULL;
-		ipn.in_dport = htons(ipn.in_dport);
+		if (ipn.in_dcmp != 0) {
+			if (pport != ipn.in_dport) {
+				fprintf(stderr,
+					"%d: mismatch in port numbers\n",
+					linenum);
+				return NULL;
+			}
+		} else
+			ipn.in_dport = htons(pport);
 
 		(void) strncpy(ipn.in_plabel, *cpp, sizeof(ipn.in_plabel));
 		cpp++;
@@ -648,6 +732,7 @@ int linenum;
 		if (ipn.in_redir == NAT_BIMAP) {
 			fprintf(stderr, "%d: cannot use portmap with bimap\n",
 				linenum);
+			*status = -1;
 			return NULL;
 		}
 		cpp++;
@@ -655,6 +740,7 @@ int linenum;
 			fprintf(stderr,
 				"%d: missing expression following portmap\n",
 				linenum);
+			*status = -1;
 			return NULL;
 		}
 
@@ -670,6 +756,7 @@ int linenum;
 			fprintf(stderr,
 				"%d: expected protocol name - got \"%s\"\n",
 				linenum, *cpp);
+			*status = -1;
 			return NULL;
 		}
 		proto = *cpp;
@@ -677,6 +764,7 @@ int linenum;
 
 		if (!*cpp) {
 			fprintf(stderr, "%d: no port range found\n", linenum);
+			*status = -1;
 			return NULL;
 		}
 
@@ -691,12 +779,15 @@ int linenum;
 				fprintf(stderr,
 					"%d: no port range in \"%s\"\n",
 					linenum, *cpp);
+				*status = -1;
 				return NULL;
 			}
 			*t++ = '\0';
 			if (!portnum(*cpp, &ipn.in_pmin, linenum) ||
-			    !portnum(t, &ipn.in_pmax, linenum))
+			    !portnum(t, &ipn.in_pmax, linenum)) {
+				*status = -1;
 				return NULL;
+			}
 			ipn.in_pmin = htons(ipn.in_pmin);
 			ipn.in_pmax = htons(ipn.in_pmax);
 			cpp++;
@@ -713,6 +804,7 @@ int linenum;
 		if (!*cpp) {
 			fprintf(stderr, "%d: age with no parameters\n",
 				linenum);
+			*status = -1;
 			return NULL;
 		}
 		ipn.in_age[0] = atoi(*cpp);
@@ -732,6 +824,7 @@ int linenum;
 		} else {
 			fprintf(stderr, "%d: mssclamp with no parameters\n",
 				linenum);
+			*status = -1;
 			return NULL;
 		}
 	}
@@ -739,8 +832,11 @@ int linenum;
 	if (*cpp) {
 		fprintf(stderr, "%d: extra junk at the end of the line: %s\n",
 			linenum, *cpp);
+		*status = -1;
 		return NULL;
 	}
+
+	*status = 0;
 	return &ipn;
 }
 
@@ -754,6 +850,7 @@ int opts;
 	ipnat_t	*np;
 	FILE	*fp;
 	int	linenum = 0;
+	int	parsestatus;
 
 	if (strcmp(file, "-")) {
 		if (!(fp = fopen(file, "r"))) {
@@ -770,11 +867,20 @@ int opts;
 		if ((s = strchr(line, '\n')))
 			*s = '\0';
 
-		if (!(np = natparse(line, linenum))) {
-			if (*line)
+		parsestatus = 1;
+		np = natparse(line, linenum, &parsestatus);
+		if (parsestatus != 0) {
+			if (*line) {
 				fprintf(stderr, "%d: syntax error in \"%s\"\n",
 					linenum, line);
-		} else {
+			}
+			fprintf(stderr, "%s: %s error (%d), quitting\n",
+			    file,
+			    ((parsestatus < 0)? "parse": "internal"),
+			    parsestatus);
+			exit(1);
+		}
+		if (np) {
 			if ((opts & OPT_VERBOSE) && np)
 				printnat(np, opts);
 			if (!(opts & OPT_NODO)) {
